import { Coordinate } from '../../../types/RealRendererTypes';
import { RealDrawBoard } from '../RealDrawBoard';
/** @internal */
export declare abstract class Tool {
    RDB: RealDrawBoard;
    constructor(RDB: RealDrawBoard);
    _onLoad(): void;
    _onUnload(): void;
    _startStroke(coords: Coordinate, identifier: string, target: EventTarget): void;
    _doStroke(coords: Coordinate, identifier: string, target: EventTarget): void;
    _endStroke(coords: Coordinate, identifier: string, target: EventTarget): void;
    _toolPreview(coords: Coordinate, identifier: string, target: EventTarget): void;
    _onScroll(scrollDelta: number, coords: Coordinate, identifier: string): void;
    _onKey(e: KeyboardEvent): void;
}
