import { Color, Coordinate } from '../../../types/RealRendererTypes';
import { Tool } from './_tool';
export declare const name = "brush";
export interface IBrushSettings {
    brushColor: Color;
    brushSize: number;
}
export declare type BrushOptions = IBrushSettings | {};
export declare const BrushDefaults: IBrushSettings;
export declare class Brush extends Tool {
    _startStroke(coords: Coordinate, identifier: string, target: EventTarget): void;
    _endStroke(endCoords: Coordinate, identifier: string, target: EventTarget): void;
    _doStroke(coords: Coordinate, identifier: string, target: EventTarget): void;
    _toolPreview(coords: Coordinate, identifier: string, target: EventTarget): void;
    _onScroll(scrollDelta: number, coords: Coordinate, identifier: string): void;
}
