"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.Brush = exports.BrushDefaults = exports.name = void 0;
var circle_1 = require("../../../pathMakers/circle");
var line_1 = require("../../../pathMakers/line");
var getRGBColorString_1 = require("../../../util/getRGBColorString");
var _path_1 = require("../../RealRenderer/strokeNodes/_path");
var getRadiusFromThickness_1 = require("./util/getRadiusFromThickness");
var _tool_1 = require("./_tool");
exports.name = 'brush';
exports.BrushDefaults = {
    brushColor: [1, 1, 1],
    brushSize: 1
};
var Brush = /** @class */ (function (_super) {
    __extends(Brush, _super);
    function Brush() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Brush.prototype._startStroke = function (coords, identifier, target) {
        this.RDB._doPreview = false;
        var brushPath = new _path_1.Path('', 'strokes');
        brushPath.setStroke(getRGBColorString_1.getRGBColorString(this.RDB.toolSettings.brushColor));
        brushPath.setStrokeWidth(this.RDB.toolSettings.brushSize);
        this.RDB._addStroke([brushPath]);
        this.RDB._strokeIdentifierMap.set(identifier, this.RDB._strokeIndex);
        this.RDB.strokes[this.RDB._strokeIdentifierMap.get(identifier)].push(circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.brushSize), this.RDB.toolSettings.brushColor, 'strokes'));
    };
    Brush.prototype._endStroke = function (endCoords, identifier, target) {
        this.RDB.strokes[this.RDB._strokeIdentifierMap.get(identifier)].push(circle_1.getCircleNode(endCoords, getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.brushSize), this.RDB.toolSettings.brushColor, 'strokes'));
        this.RDB._strokeIdentifierMap.delete(identifier);
        this.RDB._doPreview = true;
    };
    Brush.prototype._doStroke = function (coords, identifier, target) {
        this.RDB.strokes[this.RDB._strokeIdentifierMap.get(identifier)].push(circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.brushSize), this.RDB.toolSettings.brushColor, 'strokes'));
        this.RDB.strokes[this.RDB._strokeIdentifierMap.get(identifier)][0].appendPath(line_1.getLinePathCommand(this.RDB._lastCoords.get(identifier), coords));
    };
    Brush.prototype._toolPreview = function (coords, identifier, target) {
        if (!this.RDB._previewStroke.has(identifier))
            this.RDB._previewStroke.set(identifier, []);
        if (this.RDB._previewStroke.get(identifier).length == 0) {
            var circleNode = circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.brushSize), this.RDB.toolSettings.brushColor, 'overlay');
            circleNode.setFill(getRGBColorString_1.getRGBColorString(this.RDB.toolSettings.brushColor));
            circleNode.setStroke(getRGBColorString_1.getRGBColorString(this.RDB.toolSettings.brushColor));
            this.RDB._previewStroke.get(identifier).push(circleNode);
        }
        else {
            var circleNode = this.RDB._previewStroke.get(identifier)[0];
            circleNode.updateCenter(coords);
            circleNode.updateRadius(getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.brushSize));
            circleNode.setFill(getRGBColorString_1.getRGBColorString(this.RDB.toolSettings.brushColor));
            circleNode.setStroke(getRGBColorString_1.getRGBColorString(this.RDB.toolSettings.brushColor));
        }
    };
    Brush.prototype._onScroll = function (scrollDelta, coords, identifier) {
        this.RDB.changeToolSetting('brushSize', Math.max(1, this.RDB.toolSettings.brushSize - scrollDelta));
        if (this.RDB._previewStroke.get(identifier) != null && this.RDB._previewStroke.get(identifier).length !== 0) {
            this.RDB._previewStroke.get(identifier)[0].updateRadius(getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.brushSize));
            this.RDB._display(this.RDB._previewStroke.get(identifier));
        }
    };
    return Brush;
}(_tool_1.Tool));
exports.Brush = Brush;
