"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.Eraser = exports.EraserDefaults = exports.name = void 0;
var circle_1 = require("../../../pathMakers/circle");
var line_1 = require("../../../pathMakers/line");
var getRGBColorString_1 = require("../../../util/getRGBColorString");
var _path_1 = require("../../RealRenderer/strokeNodes/_path");
var getRadiusFromThickness_1 = require("./util/getRadiusFromThickness");
var _tool_1 = require("./_tool");
exports.name = 'eraser';
exports.EraserDefaults = {
    eraserSize: 2
};
var Eraser = /** @class */ (function (_super) {
    __extends(Eraser, _super);
    function Eraser() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Eraser.prototype._startStroke = function (coords, identifier, target) {
        var brushPath = new _path_1.Path('', 'strokes');
        brushPath.setStroke(getRGBColorString_1.getRGBColorString(this.RDB.bgColor));
        brushPath.setStrokeWidth(this.RDB.toolSettings.eraserSize);
        this.RDB._addStroke([brushPath]);
        this.RDB._strokeIdentifierMap.set(identifier, this.RDB._strokeIndex);
        this.RDB.strokes[this.RDB._strokeIdentifierMap.get(identifier)].push(circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.eraserSize), this.RDB.bgColor, 'strokes'));
    };
    Eraser.prototype._endStroke = function (endCoords, identifier, target) {
        this.RDB.strokes[this.RDB._strokeIdentifierMap.get(identifier)].push(circle_1.getCircleNode(endCoords, getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.eraserSize), this.RDB.bgColor, 'strokes'));
        this.RDB._doPreview = true;
    };
    Eraser.prototype._doStroke = function (coords, identifier, target) {
        this.RDB.strokes[this.RDB._strokeIdentifierMap.get(identifier)].push(circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.eraserSize), this.RDB.bgColor, 'strokes'));
        this.RDB.strokes[this.RDB._strokeIdentifierMap.get(identifier)][0].appendPath(line_1.getLinePathCommand(this.RDB._lastCoords.get(identifier), coords));
    };
    Eraser.prototype._toolPreview = function (coords, identifier, target) {
        if (this.RDB._previewStroke.get(identifier).length == 0) {
            var circleNode = circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.eraserSize), this.RDB.bgColor, 'overlay');
            circleNode.setFill(getRGBColorString_1.getRGBColorString(this.RDB.bgColor));
            circleNode.setStroke(getRGBColorString_1.getRGBColorString(this.RDB.bgColor));
            circleNode.setDashed(getRGBColorString_1.getRGBColorString(this.RDB.bgColor.map(function (c) { return 1 - c; })));
            this.RDB._previewStroke.get(identifier).push(circleNode);
        }
        else {
            var circleNode = this.RDB._previewStroke.get(identifier)[0];
            circleNode.updateCenter(coords);
            circleNode.updateRadius(getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.eraserSize));
        }
    };
    Eraser.prototype._onScroll = function (scrollDelta, coords, identifier) {
        this.RDB.changeToolSetting('eraserSize', Math.max(1, this.RDB.toolSettings.eraserSize - scrollDelta));
        if (this.RDB._previewStroke.get(identifier) != null && this.RDB._previewStroke.get(identifier).length !== 0) {
            this.RDB._previewStroke.get(identifier)[0].updateRadius(getRadiusFromThickness_1.getRadiusFromThickness(this.RDB.toolSettings.eraserSize));
            this.RDB._display(this.RDB._previewStroke.get(identifier));
        }
    };
    return Eraser;
}(_tool_1.Tool));
exports.Eraser = Eraser;
