import { Color, Coordinate } from '../../../types/RealRendererTypes';
import { Tool } from './_tool';
export declare const name = "line";
export interface ILineSettings {
    lineThickness: number;
    lineColor: Color;
}
export declare type LineOptions = ILineSettings | {};
export declare const LineDefaults: ILineSettings;
export declare class Line extends Tool {
    /** key -> identifier, value -> coordinate
     *  For mouse, the key is 'mouse', for touches, stringified identifier -> https://developer.mozilla.org/en-US/docs/Web/API/Touch/identifier
     */
    private _startCoords;
    _startStroke(coords: Coordinate, identifier: string, target: EventTarget): void;
    _endStroke(endCoords: Coordinate, identifier: string, target: EventTarget): void;
    _doStroke(coords: Coordinate, identifier: string, target: EventTarget): void;
    _toolPreview(coords: Coordinate, identifier: string, target: EventTarget): void;
    _onScroll(scrollDelta: number, coords: Coordinate, identifier: string): void;
}
