"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._onKey = exports._onScroll = exports._toolPreview = exports._doStroke = exports._endStroke = exports._startStroke = exports.TextDefaults = exports.name = void 0;
var getRGBColorString_1 = require("../../../util/getRGBColorString");
var _text_1 = require("../../RealRenderer/strokeNodes/_text");
exports.name = 'text';
exports.TextDefaults = {
    fontSize: 1,
    fontColor: [1, 1, 1],
    mode: 'new'
};
/** key -> identifier, value -> coordinate
 *  For mouse, the key is 'mouse', for touches, stringified identifier -> https://developer.mozilla.org/en-US/docs/Web/API/Touch/identifier
 */
var _startCoords = new Map(); /* key -> identifier, value -> coordinate*/
var _selectedNode;
function _startStroke(coords, identifier) {
    this._doPreview = false;
    if (this._previewStroke.has(identifier)) {
        this._previewStroke.get(identifier).forEach(function (strokeNode) {
            strokeNode.delete();
        });
    }
    var textPath = new _text_1.Text(coords, 'Myao', 'strokes');
    textPath.setFill(getRGBColorString_1.getRGBColorString(this.toolSettings.fontColor));
    textPath.setStrokeWidth(this.toolSettings.fontSize);
    this._addStroke([textPath]);
    this._strokeIdentifierMap.set(identifier, this._strokeIndex);
    _startCoords.set(identifier, coords);
    _selectedNode = textPath;
}
exports._startStroke = _startStroke;
function _endStroke(endCoords, identifier) {
}
exports._endStroke = _endStroke;
function _doStroke(coords, identifier) {
}
exports._doStroke = _doStroke;
function _toolPreview(coords, identifier) {
}
exports._toolPreview = _toolPreview;
function _onScroll(scrollDelta, coords, identifier) {
}
exports._onScroll = _onScroll;
function _onKey(e) {
    if (_selectedNode)
        _selectedNode.appendText(e.key);
}
exports._onKey = _onKey;
