import { Coordinate, SVGSection } from '../../../types/RealRendererTypes';
import { INodeData, Node } from './_node';
export interface ICircleNodeData extends INodeData {
    center: [cy: string, cy: string];
    radius: string;
    type: 'circle';
}
export declare class Circle extends Node<SVGCircleElement, 'circle'> {
    constructor(center: Coordinate, initialRadius: number, section: SVGSection);
    updateRadius(newRadius: number): void;
    updateCenter(newCenter: Coordinate): void;
    export(): ICircleNodeData;
    import(data: ICircleNodeData): void;
}
