"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupNode = void 0;
var _circle_1 = require("./_circle");
var _node_1 = require("./_node");
var _path_1 = require("./_path");
var _polygon_1 = require("./_polygon");
var _text_1 = require("./_text/_text");
var GroupNode = /** @class */ (function (_super) {
    __extends(GroupNode, _super);
    function GroupNode(section, initialInnerNodes) {
        var _this = _super.call(this, section, 'group', 'group') || this;
        _this.innerNodes = [];
        var g = document.createElementNS('http://www.w3.org/2000/svg', 'g');
        initialInnerNodes.forEach(function (node) { return g.appendChild(node.node); });
        _this.innerNodes = initialInnerNodes;
        _this.node = g;
        _this.section = section;
        return _this;
    }
    GroupNode.prototype.export = function () {
        return __assign(__assign({}, this._exportBasicData()), { innerNodes: this.innerNodes.map(function (innerNode) { return innerNode.export(); }), type: this.strokeNodeType });
    };
    GroupNode.prototype.import = function (data) {
        var _this = this;
        _super.prototype.import.call(this, data);
        this.innerNodes = data.innerNodes.map(function (strokeNodeData) {
            var _a, _b, _c, _d, _e;
            switch (strokeNodeData.type) {
                case 'circle':
                    var circ = new _circle_1.Circle([0, 0], 0, (_a = strokeNodeData.section) !== null && _a !== void 0 ? _a : 'strokes');
                    circ.import(strokeNodeData);
                    return circ;
                case 'path':
                    var path = new _path_1.Path('', (_b = strokeNodeData.section) !== null && _b !== void 0 ? _b : 'strokes');
                    path.import(strokeNodeData);
                    return path;
                case 'text':
                    var text = new _text_1.Text([0, 0], '', (_c = strokeNodeData.section) !== null && _c !== void 0 ? _c : 'strokes');
                    text.import(strokeNodeData);
                    return text;
                case 'group':
                    var group = new GroupNode((_d = strokeNodeData.section) !== null && _d !== void 0 ? _d : 'strokes', []);
                    group.import(strokeNodeData);
                    return group;
                case 'polygon':
                    var polygon = new _polygon_1.Polygon([], (_e = strokeNodeData.section) !== null && _e !== void 0 ? _e : 'strokes');
                    polygon.import(strokeNodeData);
                    return polygon;
            }
        });
        this.innerNodes.forEach(function (node) { return _this.node.appendChild(node.node); });
    };
    return GroupNode;
}(_node_1.Node));
exports.GroupNode = GroupNode;
