import { StrokeNodeDataV2, StrokeNodeType, SVGSection } from '../../../types/RealRendererTypes';
export interface INodeData {
    /** stroke attribute */
    stroke: string | null;
    /** fill attribute */
    fill: string | null;
    /** strokeWidth attribute */
    strokeWidth: string | null;
    dashed: false | {
        dashColor: string;
    };
    id: string | null;
    class: string | null;
    style: string | null;
    type: StrokeNodeType;
    section: SVGSection;
}
export declare class Node<NodeType extends SVGElement, StrokeNodeT extends StrokeNodeType> {
    node: NodeType;
    section: SVGSection;
    strokeNodeType: StrokeNodeT;
    constructor(section: SVGSection, elementName: string, strokeNodeType: StrokeNodeT);
    _exportBasicData(): INodeData;
    /** @deprecated */
    importV1(data: string): void;
    import(data: StrokeNodeDataV2): void;
    setStroke(stroke: string): void;
    setFill(fill: string): void;
    setStrokeWidth(width: number): void;
    setDashed(dashColor: string): void;
    setId(id: string): void;
    setClassName(className: string): void;
    delete(): void;
}
