"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Polygon = void 0;
var _node_1 = require("./_node");
var Polygon = /** @class */ (function (_super) {
    __extends(Polygon, _super);
    function Polygon(points, section) {
        var _this = _super.call(this, section, 'polygon', 'polygon') || this;
        var path = document.createElementNS('http://www.w3.org/2000/svg', 'polygon');
        var pointsString = '';
        points.forEach(function (point) {
            pointsString += point[0] + "," + point[1] + " ";
        });
        path.setAttribute('points', pointsString);
        _this.node = path;
        _this.section = section;
        return _this;
    }
    Polygon.prototype.updatePoints = function (newPoints) {
        var pointsString = '';
        newPoints.forEach(function (point) {
            pointsString += point[0] + "," + point[1] + " ";
        });
        this.node.setAttribute('points', pointsString);
    };
    Polygon.prototype.addPoint = function (point) {
        this.node.setAttribute('points', this.node.getAttribute('points') + (point[0] + "," + point[1] + " "));
    };
    Polygon.prototype.export = function () {
        return __assign(__assign({}, this._exportBasicData()), { points: this.node.getAttribute('points'), type: this.strokeNodeType });
    };
    Polygon.prototype.import = function (data) {
        _super.prototype.import.call(this, data);
        this.node.setAttribute('points', data.points);
    };
    return Polygon;
}(_node_1.Node));
exports.Polygon = Polygon;
