import { Coordinate, SVGSection } from '../../../types/RealRendererTypes';
import { Node } from './_node';
export declare class Text extends Node<SVGTextElement, 'text'> {
    tspans: SVGTSpanElement[];
    cursorSpan: SVGTSpanElement;
    /** The text tspan after which the cursor is placed */
    cursorIndex: number;
    /** span indexes at which a newLine starts */
    lineIndexes: number[];
    position: Coordinate;
    constructor(position: Coordinate, initialText: string, section: SVGSection);
    private _addTspan;
    private _getCurrentSpanText;
    private _updateText;
    getText(): string;
    appendText(append: string): void;
    deleteLastCharacter(): void;
    updateTextBaseline(position: Coordinate): void;
    setStyle(proprty: string, value: string): void;
    setFontSize(size: number): void;
    moveCursorLeft(): void;
    moveCursorRight(): void;
    newLine(): void;
    destroyCursor(): void;
}
