"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setUnderline = exports.setItalic = exports.setBold = exports.deleteNextCharacter = exports.deleteLastCharacter = exports.appendText = exports.getText = exports._updateAfterCursorText = exports._updateBeforeCursorText = exports._getAfterCursorText = exports._getBeforeCursorText = void 0;
function _getBeforeCursorText() {
    return this.tspans[this.cursorIndex].textContent;
}
exports._getBeforeCursorText = _getBeforeCursorText;
function _getAfterCursorText() {
    return this.tspans[this.cursorIndex + 1].textContent;
}
exports._getAfterCursorText = _getAfterCursorText;
function _updateBeforeCursorText(newText) {
    this.tspans[this.cursorIndex].textContent = newText;
    // workaround: empty svg tspans act like they do not exist
    if (this.tspans[this.cursorIndex].textContent !== '' && this.cursorIndex !== 0) {
        this._setTspanPositioning(this.cursorSpan, 'inline');
        this._setTspanPositioning(this.tspans[this.cursorIndex], 'lineBreak');
    }
}
exports._updateBeforeCursorText = _updateBeforeCursorText;
function _updateAfterCursorText(newText) {
    this.tspans[this.cursorIndex + 1].textContent = newText;
}
exports._updateAfterCursorText = _updateAfterCursorText;
function getText() {
    return this.tspans.map(function (tspan) { return tspan.textContent; }).join('');
}
exports.getText = getText;
function appendText(append) {
    this._updateBeforeCursorText(this._getBeforeCursorText() + append);
}
exports.appendText = appendText;
function deleteLastCharacter() {
    this._updateBeforeCursorText(this._getBeforeCursorText().slice(0, -1));
    // end of a newline
    if (this._getBeforeCursorText() === '' && this.cursorIndex > 0) {
        this.removeLine();
    }
}
exports.deleteLastCharacter = deleteLastCharacter;
function deleteNextCharacter() {
    this._updateAfterCursorText(this._getAfterCursorText().slice(1));
}
exports.deleteNextCharacter = deleteNextCharacter;
function setBold(bold) {
    this.setStyle('font-weight', bold ? 'bold' : 'normal');
}
exports.setBold = setBold;
function setItalic(italic) {
    this.setStyle('font-style', italic ? 'italic' : 'normal');
}
exports.setItalic = setItalic;
function setUnderline(underline) {
    this.setStyle('text-decoration', underline ? 'underline' : 'none');
}
exports.setUnderline = setUnderline;
