"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeLine = exports.newLine = void 0;
function newLine() {
    if (this.tspans[this.cursorIndex + 1] !== undefined) {
        // if there is a span after the cursor, linebreak the cursor
        this._setTspanPositioning(this.cursorSpan, 'lineBreak');
        // add a new empty span on that line
        this._addTspan('', this.cursorIndex + 1, 'spanBefore');
        // increment cursorIndex due to new span
        this.cursorIndex++;
        this.lineIndexes.push(this.cursorIndex);
        this.lineIndexes.sort(function (a, b) { return a - b; });
    }
}
exports.newLine = newLine;
function removeLine() {
    // remove the cursorIndex line
    var removedLine = this.lineIndexes.splice(this.lineIndexes.indexOf(this.cursorIndex), 1)[0];
    this.tspans[removedLine].remove();
    this.tspans.splice(removedLine, 1);
    this.lineIndexes = this.lineIndexes.map(function (i) { return i >= removedLine ? i - 1 : i; });
    this.cursorIndex = removedLine - 1;
}
exports.removeLine = removeLine;
