"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Text = void 0;
var _node_1 = require("../_node");
var _cursor_1 = require("./_cursor");
var _editing_1 = require("./_editing");
var _newlines_1 = require("./_newlines");
var Text = /** @class */ (function (_super) {
    __extends(Text, _super);
    function Text(position, initialText, section) {
        var _this = _super.call(this, section, 'text', 'text') || this;
        _this.tspans = [];
        /** The text tspan after which the cursor is placed */
        _this.cursorIndex = 0;
        /** span indexes at which a newLine starts */
        _this.lineIndexes = [];
        _this.position = [0, 0];
        _this.newLine = _newlines_1.newLine;
        _this.removeLine = _newlines_1.removeLine;
        _this.addCursor = _cursor_1.addCursor;
        _this.destroyCursor = _cursor_1.destroyCursor;
        _this.moveCursorLeft = _cursor_1.moveCursorLeft;
        _this.moveCursorRight = _cursor_1.moveCursorRight;
        _this.moveCursorDown = _cursor_1.moveCursorDown;
        _this.moveCursorUp = _cursor_1.moveCursorUp;
        _this._getBeforeCursorText = _editing_1._getBeforeCursorText;
        _this._updateBeforeCursorText = _editing_1._updateBeforeCursorText;
        _this._getAfterCursorText = _editing_1._getAfterCursorText;
        _this._updateAfterCursorText = _editing_1._updateAfterCursorText;
        _this.getText = _editing_1.getText;
        _this.appendText = _editing_1.appendText;
        _this.deleteLastCharacter = _editing_1.deleteLastCharacter;
        _this.deleteNextCharacter = _editing_1.deleteNextCharacter;
        _this.setBold = _editing_1.setBold;
        _this.setItalic = _editing_1.setItalic;
        _this.setUnderline = _editing_1.setUnderline;
        var path = document.createElementNS('http://www.w3.org/2000/svg', 'text');
        _this.node = path;
        _this.section = section;
        _this.node.setAttribute('text-anchor', 'middle');
        _this._addTspan(initialText);
        _this.cursorSpan = document.createElementNS('http://www.w3.org/2000/svg', 'tspan');
        _this.node.appendChild(_this.cursorSpan);
        _this.cursorSpan.classList.add('svg-real-db-text-cursor');
        _this.cursorSpan.style.setProperty('position', 'relative');
        _this.cursorSpan.textContent = '|';
        _this.cursorIndex = 0;
        _this._addTspan('', _this.cursorIndex + 1); // span after cursor
        _this.lineIndexes.push(0);
        _this.position = __spreadArrays(position);
        _this.node.setAttribute('x', (_this.position[0]).toString());
        _this.node.setAttribute('y', _this.position[1].toString());
        return _this;
    }
    Text.prototype._addTspan = function (text, index, relativeTo) {
        if (index === void 0) { index = 0; }
        if (relativeTo === void 0) { relativeTo = 'spanAfter'; }
        this.lineIndexes = this.lineIndexes.map(function (i) { return i >= index ? i + 1 : i; });
        this.tspans.splice(index, 0, document.createElementNS('http://www.w3.org/2000/svg', 'tspan'));
        var newTspan = this.tspans[index];
        if (relativeTo === 'spanAfter') {
            if (this.tspans[index + 1] !== undefined)
                this.tspans[index + 1].insertAdjacentElement('beforebegin', newTspan);
            else
                this.node.insertAdjacentElement('beforeend', newTspan);
        }
        else {
            if (this.tspans[index - 1] !== undefined)
                this.tspans[index - 1].insertAdjacentElement('afterend', newTspan);
            else
                this.node.insertAdjacentElement('afterbegin', newTspan);
        }
        newTspan.textContent = text;
        newTspan.style.setProperty('whiteSpace', 'pre');
    };
    Text.prototype._setTspanPositioning = function (tspan, positioningType) {
        if (positioningType === 'lineBreak') {
            tspan.setAttribute('x', this.position[0].toString());
            tspan.setAttribute('dy', 1.2 + "em");
        }
        else if (positioningType === 'inline') {
            tspan.removeAttribute('x');
            tspan.removeAttribute('dy');
        }
    };
    Text.prototype.updateTextBaseline = function (position) {
        this.node.setAttribute('x', position[0].toString());
        this.node.setAttribute('y', position[1].toString());
        this.tspans.forEach(function (tspan) {
            if (tspan.hasAttribute('x'))
                tspan.setAttribute('x', position[0].toString());
        });
    };
    Text.prototype.setStyle = function (property, value) {
        this.node.style.setProperty(property, value);
    };
    Text.prototype.setFontSize = function (size) {
        this.node.style.fontSize = size + "px";
    };
    /** @deprecated */
    Text.prototype.importV1 = function (data) {
        var _this = this;
        _super.prototype.importV1.call(this, data);
        this.position = [
            Number(this.node.getAttribute('x')),
            Number(this.node.getAttribute('y'))
        ];
        this.tspans = [];
        this.lineIndexes = [];
        this.cursorIndex = 0;
        this.node.childNodes.forEach(function (node) {
            if (node instanceof SVGTSpanElement) {
                var numTspans = _this.tspans.push(node);
                if (node.hasAttribute('dy'))
                    _this.lineIndexes.push(numTspans - 1);
            }
        });
        this.lineIndexes.sort(function (a, b) { return a - b; });
        this.destroyCursor();
    };
    Text.prototype.import = function (data) {
        var _this = this;
        _super.prototype.import.call(this, data);
        this.tspans = data.tspans.map(function (tspan) {
            var tspan_ = document.createElementNS('http://www.w3.org/2000/svg', 'tspan');
            tspan_.textContent = tspan.textContent;
            if (tspan.dy !== null)
                tspan_.setAttribute('dy', tspan.dy);
            if (tspan.x !== null)
                tspan_.setAttribute('x', tspan.x);
            _this.node.append(tspan_);
            return tspan_;
        });
        this.position = data.position;
        this.updateTextBaseline(this.position);
        this.destroyCursor();
    };
    Text.prototype.export = function () {
        return __assign(__assign({}, this._exportBasicData()), { position: this.position, tspans: this.tspans.map(function (tspan) {
                return {
                    x: tspan.hasAttribute('x') ? tspan.getAttribute('x') : null,
                    dy: tspan.hasAttribute('dy') ? tspan.getAttribute('dy') : null,
                    textContent: tspan.textContent
                };
            }), type: this.strokeNodeType });
    };
    return Text;
}(_node_1.Node));
exports.Text = Text;
